#!/bin/bash

clear
echo "###############################################################################"
echo "    Welcome to WHM Resource Monitor plugin Installation"
echo "###############################################################################"
rspath=/usr/local/cpanel/whostmgr/cgi/rsmonitor
rsfile=/usr/local/cpanel/whostmgr/cgi/addon_resource_monitor.cgi
rsloc=/usr/local/cpanel/whostmgr/cgi
rslog=/home/rsmonlog
rsthumb=/usr/local/cpanel/whostmgr/docroot/themes/x/icons
rscpath=/usr/local/cpanel/base/frontend/x3/rsmonitor
pvs=$(/usr/local/cpanel/3rdparty/bin/php -v | head -1 | awk '{print $2}' | awk -F. '{print $1$2}')
if [ $pvs -eq "55" ];then
  pvs="54"
else
  if [ $pvs -eq "56" ];then
    pvs="54"
  fi
fi
d=`date "+%b%d"`
export who=`whoami`
if [[ $who == "root" ]];then
echo "Installation proceedings....."
echo "If you want to cancel Installation press Ctrl+C Or installation will begin within 5 seconds..........."
sleep 5

echo "Checking Support modules....."
chk=$(grep -r "ioncube" /usr/local/cpanel/3rdparty/etc/php.ini | cut -d'=' -f1)
curlchk=$(/usr/local/cpanel/3rdparty/bin/php -i | grep cURL)
if [ "$chk" == "" ]; then
        echo "IonCube Loader is not installed, Please install WHM->Tweak Settings->PHP"
        if [ "$curlchk" == "" ];then
        echo "cURL is not Installed"
        fi
exit 0
else
echo "IonCube Loader is Installed"
        if [ "$curlchk" == "" ];then
        echo "cURL is not Installed. Please install cURL in your server and then run /scripts/makecpphp"
exit 0
        else
        echo "cURL is Installed"
        fi
fi

if [ -d "$rspath" ];then
echo "WHM Resource Monitor already installed ! If you want to unistall WHM Resource Monitor use 'uninstall.sh' file"
exit 1
else

echo -n "Enter your Resource Monitor License: "
read licen
if [ "$licen" == "" ]; then
        echo -n "Enter valid license key: "
        read licen
        if [ "$licen" == "" ]; then
          echo "License Key should not be empty.. Exit!!"
          exit 0
        else
          echo $licen > ./$pvs/rsmonitor/whm_panel/licensekey.txt
        fi
else
echo $licen > ./$pvs/rsmonitor/whm_panel/licensekey.txt
fi

echo "WHM Resource Monitor Installation begins ..."
find $rsloc -iname "addon_resource_monitor.cgi" -type f -exec /bin/mv {} /tmp \;
mv ./addon_resource_monitor.cgi $rsloc
cp -f ./resourceMonitor.png $rsthumb
mv ./$pvs/rsmonitor $rsloc
cp -Rf /usr/local/cpanel/3rdparty/etc/php.ini $rsloc/rsmonitor/
if [ -d $rslog ];then
mv $rslog $rslog.$d
fi
mkdir $rslog
/usr/bin/rsync -avz ./user_logview.xml $rslog

###WHM plugin Registration####

if [ "$cpv" -lt 38 ]; then
echo "Plugin registration is not needed"
else
        if [ ! -d "/var/cpanel/apps" ]; then
        mkdir /var/cpanel/apps
        chmod 755 /var/cpanel/apps
        /usr/local/cpanel/bin/register_appconfig addon_resource_monitor.conf
        else
        /usr/local/cpanel/bin/register_appconfig addon_resource_monitor.conf
        fi
fi

clear
###############################################################################
echo "WHM Resource Monitor Installation Completed"
echo "Login into your WHM -->Plugins -->Resource monitor"
###############################################################################
fi

#############################
#cPanel Plugin Installation #
#############################

if [ -d "$rscpath" ];then
echo "WHM Resource Monitor directory found!"
mv $rscpath $rscpath.$d
echo "Moved to $rscpath.$d"
fi
/usr/bin/rsync -avz ./rsmonitor.cpanelplugin /usr/local/cpanel/3rdparty
#echo "WHM Resource Monitor cPanel Plugin installation started.."
# /usr/local/cpanel/bin/register_cpanelplugin ./rsmonitor.cpanelplugin
# /usr/bin/rsync -avz  ./$pvs/cpanel/rsmonitor /usr/local/cpanel/base/frontend/x3

#Theme Support for Paper Lantern
/usr/bin/rsync -avz  ./$pvs/cpanel/rsmonitor /usr/local/cpanel/base/frontend/paper_lantern
/usr/local/cpanel/scripts/install_plugin .

echo '*/5 * * * * /usr/local/cpanel/3rdparty/bin/php -q /usr/local/cpanel/whostmgr/docroot/cgi/rsmonitor/cron.php' >> /var/spool/cron/root
/usr/local/cpanel/3rdparty/bin/php -q $rsloc/rsmonitor/cron.php
/etc/init.d/crond restart
echo "Cron Settings updated"
rm -rf ../rsmonitor
chmod 755 /home/rsmonlog -R
else
echo "You need root user privileges to continue Installation"
exit 1
fi

